﻿///////////////////////////////////////////////////////////////////////////////
//  INSTITUTO NACIONAL DE PESQUISAS ESPACIAIS
//  Simubox - SMP2 Model Development Kit
///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2014, Leandro Toss Hoffmann (INPE)> <leandro.hoffmann@inpe.br >
// Permission to use, copy, modify, and distribute this model for any purpose with or without fee is hereby granted, provided that the above copyright notice and this permission notice appear in all copies.
// This model is provided "as is" and the author disclaims all warranties with regard to it. 
///////////////////////////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SMP2CodeGen
{
    public partial class CodeGenDialog : Form
    {
        public CodeGenDialog()
        {
            InitializeComponent();
        }

        public string GetPath()
        {
            return textPath.Text;
        }

        private void buttonPath_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                textPath.Text = folderBrowserDialog1.SelectedPath;
            }

            if (textPath.Text != "")
                buttonGenerate.Enabled = true;
            else
                buttonGenerate.Enabled = false;
        }

        private void buttonGenerate_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        private void onTextPath_changed(object sender, EventArgs e)
        {
            if(textPath.Text != "")
                buttonGenerate.Enabled = true;
            else
                buttonGenerate.Enabled = false;
        }
    }
}
