#include "RootModel.h"
#include "Sb/EntryPoint.h"

// Unique identifier of type RootModel
// UUID: FBFA7FA6-0D14-4ae7-AE8B-EE9E9D8E2FE5
const SB::Uuid Catalogue::Uuid_RootModel("FBFA7FA6-0D14-4ae7-AE8B-EE9E9D8E2FE5");

Catalogue::RootModel::RootModel()
{
	_Init();
}

Catalogue::RootModel::RootModel(Smp::String8 name, Smp::String8 description, Smp::IComposite* parent)
	throw (Smp::Management::IManagedObject::InvalidObjectName)
  : SB::Management::ManagedModel(name, description, parent)
{
	_Init();
}

Catalogue::RootModel::~RootModel()
{
	try {
		_Destroy();
	} catch (...) {
		m_simulator->GetLogger()->Log(
		this,
		"Exception during destruction of model 'SASModel'",
		::Smp::Services::LMK_Error);
	}
}
void Catalogue::RootModel::_Init()
{

	//////// Entry Points

	//////// References

	//////// Containers
	_ContainerA = SB::Management::ManagedContainer< Model1_Level1 >::CreateInstance(
		"ContainerA" 
		, ""
		, this
	);
		ContainerA = _ContainerA;

	_ContainerB = SB::Management::ManagedContainer< Model2_Level1 >::CreateInstance(
		"ContainerB" 
		, ""
		, this
		, 0
		, 1
	);
		ContainerB = _ContainerB;

	_ContainerC = SB::Management::ManagedContainer< Model3_Level1 >::CreateInstance(
		"ContainerC" 
		, ""
		, this
		, 0
	);
		ContainerC = _ContainerC;


	//////// Initialising fields to zero values
	//////// Initialising fields to initial values
}

void Catalogue::RootModel::_Destroy()
{
}

/// ------------------------------------------------------
/// --------------------- Operations ---------------------


/// ------------------------------------------------------
/// --------------------- Entry Points ---------------------
/// --------------------------------------------------------
/// --------------------- IModel ---------------------
void Catalogue::RootModel::Configure(Smp::Services::ILogger* logger) throw (Smp::IModel::InvalidModelState)
{
	// User code here

	// At the end call method from base class
	SB::Model::Configure(logger);
}

void Catalogue::RootModel::Connect(Smp::ISimulator* simulator) throw (Smp::IModel::InvalidModelState)
{
	// User code here

	// At the end call method from base class
	SB::Model::Connect(simulator);
}

void Catalogue::RootModel::Publish(Smp::IPublication* receiver) throw (Smp::IModel::InvalidModelState)
{

	// Call base implementation first
	SB::Model::Publish(receiver);

	// ----- Publish Fields

}

