///////////////////////////////////////////////////////////////////////////////
//  INSTITUTO NACIONAL DE PESQUISAS ESPACIAIS
//  Simubox - SMP2 Model Development Kit
///////////////////////////////////////////////////////////////////////////////
//  File RootModel.h generated by Simubox's SMP2 Code Generator
//  Definition of Class RootModel
//  Date:      19-jun-2013 15:35:46
//  Author: LT Hoffmann
///////////////////////////////////////////////////////////////////////////////

#if !defined(TESTCASES_ROOTMODEL_H)
#define TESTCASES_ROOTMODEL_H

#include "Sb/SimpleTypes.h"
#include "Sb/Management/ManagedModel.h"
#include "Sb/Management/EntryPointPublisher.h"
#include "Sb/Management/ManagedContainer.h"
#include "Model1_Level1.h"
#include "Model2_Level1.h"
#include "Model3_Level1.h"

namespace Catalogue
{
	// Unique identifier of type RootModel
	// UUID: {FBFA7FA6-0D14-4ae7-AE8B-EE9E9D8E2FE5}
	extern const SB::Uuid Uuid_RootModel;
	
	/**
	 * @author LT Hoffmann
	 * @version 1.0
	 * @created 19-jun-2013 15:35:51
	 */
	class RootModel : public virtual SB::Management::ManagedModel, public virtual SB::Management::EntryPointPublisher, public virtual SB::Composite
	{
		//
		// ------------------------ Constructors and Destructor -----------------------
		//
		public:
				RootModel();
				RootModel(Smp::String8 name,
							Smp::String8 description,
							Smp::IComposite* parent)
							throw (::Smp::Management::IManagedObject::InvalidObjectName);
				virtual ~RootModel();
	

		//
		// ------------------------ Setup and cleanup services ------------------------
		//
		private: 
				void _Init();
				void _Destroy();
	//
		// -------------------------------- Containers --------------------------------
		//
			/// 
		protected:
                SB::Management::ManagedContainer< Model1_Level1 >* _ContainerA;
		public:
				Smp::Management::IManagedContainer* ContainerA;
		/// 
		protected:
                SB::Management::ManagedContainer< Model2_Level1 >* _ContainerB;
		public:
				Smp::Management::IManagedContainer* ContainerB;
		/// 
		protected:
                SB::Management::ManagedContainer< Model3_Level1 >* _ContainerC;
		public:
				Smp::Management::IManagedContainer* ContainerC;
	

		//
		// ---------------------------------- IModel ----------------------------------
		//
		public:
			void Publish(Smp::IPublication* receiver) throw (Smp::IModel::InvalidModelState);
			void Configure(Smp::Services::ILogger* logger) throw (Smp::IModel::InvalidModelState);
			void Connect(Smp::ISimulator* simulator) throw (Smp::IModel::InvalidModelState);


	}; // Model RootModel

}
#endif // !defined(TESTCASES_ROOTMODEL_H)
