///////////////////////////////////////////////////////////////////////////////
//  INSTITUTO NACIONAL DE PESQUISAS ESPACIAIS
//  Simubox - SMP2 Model Development Kit
///////////////////////////////////////////////////////////////////////////////
//  File ModelFields.h generated by Simubox's SMP2 Code Generator
//  Definition of Class ModelFields
//  Date:      19-jun-2013 13:55:09
///////////////////////////////////////////////////////////////////////////////

#if !defined(TESTCASES_MODELFIELDS_H)
#define TESTCASES_MODELFIELDS_H

#include "Sb/SimpleTypes.h"
#include "Sb/Management/ManagedModel.h"
#include "Sb/Management/EntryPointPublisher.h"

namespace Catalogue
{
	// Unique identifier of type ModelFields
	// UUID: {378B9821-00B9-4301-8A61-1B5260A0E3E1}
	extern const SB::Uuid Uuid_ModelFields;
	
	/**
	 * Model to test many types of fields.
	 * @version 1.0
	 * @created 19-jun-2013 13:55:10
	 */
	class ModelFields : public virtual SB::Management::ManagedModel, public virtual SB::Management::EntryPointPublisher
	{
		//
		// ------------------------ Constructors and Destructor -----------------------
		//
		public:
				ModelFields();
				ModelFields(Smp::String8 name,
							Smp::String8 description,
							Smp::IComposite* parent)
							throw (::Smp::Management::IManagedObject::InvalidObjectName);
				virtual ~ModelFields();
	

		//
		// ------------------------ Setup and cleanup services ------------------------
		//
		private: 
				void _Init();
				void _Destroy();
		//
		// --------------------------------- Fields ---------------------------------
		//
		/// Simple Field1
		private: Smp::Int32 simpleField1;
		/// 
		private: Smp::Bool simpleField2;
		/// 
		private: Smp::String8 simpleField3;
		/// 
		private: Smp::Duration simpleField4;
		/// 
		private: Smp::Int16 simpleArray1[1];
		/// 
		private: Smp::Float32 simpleArray2[2];
		/// 
		private: Smp::Float64 simpleArray3[3];
		/// 
		private: Smp::Int64 simpleArray4[4];


			// ----< Input fields >----
			//
	
		/// 
		public: Smp::Int32 inputField1;
		/// 
		public: Smp::String8 inputField2;
		/// 
		public: Smp::Int16 inputField3[1];
		/// 
		public: Smp::Float64 inputField4[3];
			// ----< Output fields >----
			//
	
		/// 
		public: Smp::Bool outputField1;
		/// 
		public: Smp::Duration outputField2;
		/// 
		public: Smp::Float32 outputField3[2];
		/// 
		public: Smp::Int64 outputField4[4];
	

		//
		// ---------------------------------- IModel ----------------------------------
		//
		public:
			void Publish(Smp::IPublication* receiver) throw (Smp::IModel::InvalidModelState);
			void Configure(Smp::Services::ILogger* logger) throw (Smp::IModel::InvalidModelState);
			void Connect(Smp::ISimulator* simulator) throw (Smp::IModel::InvalidModelState);


	}; // Model ModelFields

}
#endif // !defined(TESTCASES_MODELFIELDS_H)
