///////////////////////////////////////////////////////////////////////////////
//  INSTITUTO NACIONAL DE PESQUISAS ESPACIAIS
//  Simubox - SMP2 Model Development Kit
///////////////////////////////////////////////////////////////////////////////
//  File ModelInterfaces.h generated by Simubox's SMP2 Code Generator
//  Definition of Class ModelInterfaces
//  Date:      19-jun-2013 13:54:51
//  Author: LT Hoffmann
///////////////////////////////////////////////////////////////////////////////

#if !defined(TESTCASES_MODELINTERFACES_H)
#define TESTCASES_MODELINTERFACES_H

#include "Sb/SimpleTypes.h"
#include "Sb/Management/ManagedModel.h"
#include "Sb/Management/EntryPointPublisher.h"
#include "IModelInterfaces.h"
#include "IModelInterface2.h"


namespace Catalogue
{
	// Unique identifier of type ModelInterfaces
	// UUID: {1567EAE2-7F4D-4dd6-9634-1CD30BB39536}
	extern const SB::Uuid Uuid_ModelInterfaces;
	
	/**
	 * @author LT Hoffmann
	 * @version 1.0
	 * @created 19-jun-2013 13:54:51
	 */
	class ModelInterfaces : public virtual SB::Management::ManagedModel, public virtual SB::Management::EntryPointPublisher, public virtual IModelInterfaces, public virtual IModelInterface2
	{
		//
		// ------------------------ Constructors and Destructor -----------------------
		//
		public:
				ModelInterfaces();
				ModelInterfaces(Smp::String8 name,
							Smp::String8 description,
							Smp::IComposite* parent)
							throw (::Smp::Management::IManagedObject::InvalidObjectName);
				virtual ~ModelInterfaces();
	

		//
		// ------------------------ Setup and cleanup services ------------------------
		//
		private: 
				void _Init();
				void _Destroy();
		//
		// ------------------------- Implemented interfaces -------------------------
		//

		/**
		  * Implementation of base method IModelInterface2::serviceInterface1
		  */
		virtual void serviceInterface1();
		/**
		  * Implementation of base method IModelInterface2::serviceInterface2
		  */
		virtual Smp::Int16 serviceInterface2(Smp::Bool param1);


		//
		// ---------------------------------- IModel ----------------------------------
		//
		public:
			void Publish(Smp::IPublication* receiver) throw (Smp::IModel::InvalidModelState);
			void Configure(Smp::Services::ILogger* logger) throw (Smp::IModel::InvalidModelState);
			void Connect(Smp::ISimulator* simulator) throw (Smp::IModel::InvalidModelState);


	}; // Model ModelInterfaces

}
#endif // !defined(TESTCASES_MODELINTERFACES_H)
