#include "ModelOperations.h"
#include "Sb/EntryPoint.h"

// Unique identifier of type ModelOperations
// UUID: 7E47EC1F-CCA3-4d4f-9CEC-3E2A7758B5E6
const SB::Uuid Test::Uuid_ModelOperations("7E47EC1F-CCA3-4d4f-9CEC-3E2A7758B5E6");

Test::ModelOperations::ModelOperations()
{
	_Init();
}

Test::ModelOperations::ModelOperations(Smp::String8 name, Smp::String8 description, Smp::IComposite* parent)
	throw (Smp::Management::IManagedObject::InvalidObjectName)
  : SB::Management::ManagedModel(name, description, parent)
{
	_Init();
}

Test::ModelOperations::~ModelOperations()
{
	try {
		_Destroy();
	} catch (...) {
		m_simulator->GetLogger()->Log(
		this,
		"Exception during destruction of model 'SASModel'",
		::Smp::Services::LMK_Error);
	}
}
void Test::ModelOperations::_Init()
{

	//////// Entry Points
	this->entryPoint1 = new SB::EntryPoint< Test::ModelOperations >(
		"entryPoint1",
		"Entry point 1",
		this,
		&Test::ModelOperations::_entryPoint1);
	this->AddEntryPoint(entryPoint1);
	this->entryPoint2 = new SB::EntryPoint< Test::ModelOperations >(
		"entryPoint2",
		"Entry point 2",
		this,
		&Test::ModelOperations::_entryPoint2);
	this->AddEntryPoint(entryPoint2);

	//////// References

	//////// Containers

	//////// Initialising fields to zero values
	//////// Initialising fields to initial values
}

void Test::ModelOperations::_Destroy()
{
	delete(this->entryPoint1);
	delete(this->entryPoint2);
}

/// ------------------------------------------------------
/// --------------------- Operations ---------------------


/// ------------------------------------------------------
/// --------------------- Entry Points ---------------------
void Test::ModelOperations::_entryPoint1()
{
	// 
}

void Test::ModelOperations::_entryPoint2()
{
	// 
}

/// --------------------------------------------------------
/// --------------------- IModel ---------------------
void Test::ModelOperations::Configure(Smp::Services::ILogger* logger) throw (Smp::IModel::InvalidModelState)
{
	// User code here

	// At the end call method from base class
	SB::Model::Configure(logger);
}

void Test::ModelOperations::Connect(Smp::ISimulator* simulator) throw (Smp::IModel::InvalidModelState)
{
	// User code here

	// At the end call method from base class
	SB::Model::Connect(simulator);
}

void Test::ModelOperations::Publish(Smp::IPublication* receiver) throw (Smp::IModel::InvalidModelState)
{
	// Temp reference to publish operation's parameters
	Smp::Publication::IPublishOperation* operation = NULL;

	// Call base implementation first
	SB::Model::Publish(receiver);

	// ----- Publish Operations
	// entryPoint1
	operation = receiver->PublishOperation(
		"entryPoint1",
		"Entry point 1",
		Smp::VK_None);

	// entryPoint2
	operation = receiver->PublishOperation(
		"entryPoint2",
		"Entry point 2",
		Smp::VK_None);

	// Operation1
	operation = receiver->PublishOperation(
		"Operation1",
		"Operation 1",
		Smp::VK_None);

	// Operation2
	operation = receiver->PublishOperation(
		"Operation2",
		"",
		Smp::VK_None);

	if(operation) {
		operation->PublishParameter(
			"param1",
			"parameter 1",
			Smp::Uuid_Int32,
			Smp::Publication::PDK_In);

	}

	// Operation3
	operation = receiver->PublishOperation(
		"Operation3",
		"",
		Smp::VK_None);

	if(operation) {
		operation->PublishParameter(
			"Return",
			"Return Parameter",
			Smp::Uuid_Int16,
			 Smp::Publication::PDK_Return);

		operation->PublishParameter(
			"param3",
			"",
			Smp::Uuid_Char8,
			Smp::Publication::PDK_Out);

		operation->PublishParameter(
			"param2",
			"",
			Smp::Uuid_Float64,
			Smp::Publication::PDK_Out);

		operation->PublishParameter(
			"param1",
			"",
			Smp::Uuid_Duration,
			Smp::Publication::PDK_InOut);

	}

	// Operation4
	operation = receiver->PublishOperation(
		"Operation4",
		"",
		Smp::VK_None);

	if(operation) {
		operation->PublishParameter(
			"Return",
			"Return Parameter",
			Smp::Uuid_String8,
			 Smp::Publication::PDK_Return);

		operation->PublishParameter(
			"param2",
			"",
			Smp::Uuid_DateTime,
			Smp::Publication::PDK_In);

		operation->PublishParameter(
			"param1",
			"",
			Smp::Uuid_Bool,
			Smp::Publication::PDK_Out);

	}


	// ----- Publish Fields

}

