///////////////////////////////////////////////////////////////////////////////
//  INSTITUTO NACIONAL DE PESQUISAS ESPACIAIS
//  Simubox - SMP2 Model Development Kit
///////////////////////////////////////////////////////////////////////////////
//  File ModelOperations.h generated by Simubox's SMP2 Code Generator
//  Definition of Class ModelOperations
//  Date:      19-jun-2013 13:54:57
//  Author: LT Hoffmann
///////////////////////////////////////////////////////////////////////////////

#if !defined(TESTCASES_MODELOPERATIONS_H)
#define TESTCASES_MODELOPERATIONS_H

#include "Sb/SimpleTypes.h"
#include "Sb/Management/ManagedModel.h"
#include "Sb/Management/EntryPointPublisher.h"

namespace Catalogue
{
	// Unique identifier of type ModelOperations
	// UUID: {7E47EC1F-CCA3-4d4f-9CEC-3E2A7758B5E6}
	extern const SB::Uuid Uuid_ModelOperations;
	
	/**
	 * @author LT Hoffmann
	 * @version 1.0
	 * @created 19-jun-2013 13:54:57
	 */
	class ModelOperations : public virtual SB::Management::ManagedModel, public virtual SB::Management::EntryPointPublisher
	{
		//
		// ------------------------ Constructors and Destructor -----------------------
		//
		public:
				ModelOperations();
				ModelOperations(Smp::String8 name,
							Smp::String8 description,
							Smp::IComposite* parent)
							throw (::Smp::Management::IManagedObject::InvalidObjectName);
				virtual ~ModelOperations();
	

		//
		// ------------------------ Setup and cleanup services ------------------------
		//
		private: 
				void _Init();
				void _Destroy();
	//
		// -------------------------------- Operations ------------------------------
		//
		/**
		 * Operation 1
		 */
		void Operation1();
		/**
		 * 
		 * @param param1    parameter 1
		 */
		void Operation2(Smp::Int32 param1);
		/**
		 * 
		 * @param param3
		 * @param param2
		 * @param param1
		 */
		Smp::Int16 Operation3(Smp::Char8 param3, Smp::Float64 param2, Smp::Duration param1);
		/**
		 * 
		 * @param param2
		 * @param param1
		 */
		Smp::String8 Operation4(Smp::DateTime param2, Smp::Bool param1);
		//
		// ------------------------------ Entry Points ------------------------------
		//
		/**
		 * Entry point 1
		 */
		public: ::Smp::IEntryPoint* entryPoint1;
		public: void _entryPoint1();
		/**
		 * Entry point 2
		 */
		public: ::Smp::IEntryPoint* entryPoint2;
		public: void _entryPoint2();


		//
		// ---------------------------------- IModel ----------------------------------
		//
		public:
			void Publish(Smp::IPublication* receiver) throw (Smp::IModel::InvalidModelState);
			void Configure(Smp::Services::ILogger* logger) throw (Smp::IModel::InvalidModelState);
			void Connect(Smp::ISimulator* simulator) throw (Smp::IModel::InvalidModelState);


	}; // Model ModelOperations

}
#endif // !defined(TESTCASES_MODELOPERATIONS_H)
