#include "ModelReferences.h"
#include "Sb/EntryPoint.h"

// Unique identifier of type ModelReferences
// UUID: 1F570F47-BDBC-4619-9778-B8883C186509
const SB::Uuid Catalogue::Uuid_ModelReferences("1F570F47-BDBC-4619-9778-B8883C186509");

Catalogue::ModelReferences::ModelReferences()
{
	_Init();
}

Catalogue::ModelReferences::ModelReferences(Smp::String8 name, Smp::String8 description, Smp::IComposite* parent)
	throw (Smp::Management::IManagedObject::InvalidObjectName)
  : SB::Management::ManagedModel(name, description, parent)
{
	_Init();
}

Catalogue::ModelReferences::~ModelReferences()
{
	try {
		_Destroy();
	} catch (...) {
		m_simulator->GetLogger()->Log(
		this,
		"Exception during destruction of model 'SASModel'",
		::Smp::Services::LMK_Error);
	}
}
void Catalogue::ModelReferences::_Init()
{

	//////// Entry Points

	//////// References
	_Environment = SB::Management::ManagedReference< IEnvironment >::CreateInstance(
		"Environment" 
		, ""
		, this
		, 0
		, 1
	);
	Environment = _Environment;

	_Equipments = SB::Management::ManagedReference< IEquipment >::CreateInstance(
		"Equipments" 
		, ""
		, this
		, 0
	);
	Equipments = _Equipments;

	_Subsystems = SB::Management::ManagedReference< ISubsystem >::CreateInstance(
		"Subsystems" 
		, ""
		, this
	);
	Subsystems = _Subsystems;


	//////// Containers

	//////// Initialising fields to zero values
	//////// Initialising fields to initial values
}

void Catalogue::ModelReferences::_Destroy()
{
}

/// ------------------------------------------------------
/// --------------------- Operations ---------------------


/// ------------------------------------------------------
/// --------------------- Entry Points ---------------------
/// --------------------------------------------------------
/// --------------------- IModel ---------------------
void Catalogue::ModelReferences::Configure(Smp::Services::ILogger* logger) throw (Smp::IModel::InvalidModelState)
{
	// User code here

	// At the end call method from base class
	SB::Model::Configure(logger);
}

void Catalogue::ModelReferences::Connect(Smp::ISimulator* simulator) throw (Smp::IModel::InvalidModelState)
{
	// User code here

	// At the end call method from base class
	SB::Model::Connect(simulator);
}

void Catalogue::ModelReferences::Publish(Smp::IPublication* receiver) throw (Smp::IModel::InvalidModelState)
{
	// Temp reference to publish operation's parameters
	Smp::Publication::IPublishOperation* operation = NULL;

	// Call base implementation first
	SB::Model::Publish(receiver);

	// ----- Publish Fields

}

