///////////////////////////////////////////////////////////////////////////////
//  INSTITUTO NACIONAL DE PESQUISAS ESPACIAIS
//  Simubox - SMP2 Model Development Kit
///////////////////////////////////////////////////////////////////////////////
//  File ModelReferences.h generated by Simubox's SMP2 Code Generator
//  Definition of Class ModelReferences
//  Date:      19-jun-2013 14:02:12
//  Author: LT Hoffmann
///////////////////////////////////////////////////////////////////////////////

#if !defined(TESTCASES_MODELREFERENCES_H)
#define TESTCASES_MODELREFERENCES_H

#include "Sb/SimpleTypes.h"
#include "Sb/Management/ManagedModel.h"
#include "Sb/Management/EntryPointPublisher.h"
#include "Sb/Management/ManagedReference.h"
#include "IEnvironment.h"
#include "IEquipment.h"
#include "ISubsystem.h"

namespace Catalogue
{
	// Unique identifier of type ModelReferences
	// UUID: {1F570F47-BDBC-4619-9778-B8883C186509}
	extern const SB::Uuid Uuid_ModelReferences;
	
	/**
	 * @author LT Hoffmann
	 * @version 1.0
	 * @created 19-jun-2013 14:02:12
	 */
	class ModelReferences : public virtual SB::Management::ManagedModel, public virtual SB::Management::EntryPointPublisher, public virtual SB::Aggregate
	{
		//
		// ------------------------ Constructors and Destructor -----------------------
		//
		public:
				ModelReferences();
				ModelReferences(Smp::String8 name,
							Smp::String8 description,
							Smp::IComposite* parent)
							throw (::Smp::Management::IManagedObject::InvalidObjectName);
				virtual ~ModelReferences();
	

		//
		// ------------------------ Setup and cleanup services ------------------------
		//
		private: 
				void _Init();
				void _Destroy();
	//
		// -------------------------------- References --------------------------------
		//
	
		/// 
		protected: SB::Management::ManagedReference< IEnvironment >* _Environment;
		protected: Smp::Management::IManagedReference* Environment;
		/// 
		protected: SB::Management::ManagedReference< IEquipment >* _Equipments;
		protected: Smp::Management::IManagedReference* Equipments;
		/// 
		protected: SB::Management::ManagedReference< ISubsystem >* _Subsystems;
		protected: Smp::Management::IManagedReference* Subsystems;
	

		//
		// ---------------------------------- IModel ----------------------------------
		//
		public:
			void Publish(Smp::IPublication* receiver) throw (Smp::IModel::InvalidModelState);
			void Configure(Smp::Services::ILogger* logger) throw (Smp::IModel::InvalidModelState);
			void Connect(Smp::ISimulator* simulator) throw (Smp::IModel::InvalidModelState);


	}; // Model ModelReferences

}
#endif // !defined(TESTCASES_MODELREFERENCES_H)
